searchData={"content_type":"text/markdown","items":[{"doc":"ExAcme is an ACME protocol client for managing SSL certificates.\n\nIt provides functionalities to interact with the ACME server, including\ngenerating keys, sending ACME requests, and handling directory and nonce\ninformation.","ref":"ExAcme.html","title":"ExAcme","type":"module"},{"doc":"- Start and manage the ExAcme client agent.\n  - Fetch directory information and terms of service.\n  - Send signed ACME requests.\n  - Handle nonce refreshing automatically.\n\nUse the client to interact with ACME endpoints.","ref":"ExAcme.html#module-features","title":"Features - ExAcme","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExAcme.html#child_spec/1","title":"ExAcme.child_spec/1","type":"function"},{"doc":"Client process holding directory cache and state","ref":"ExAcme.html#t:client/0","title":"ExAcme.client/0","type":"type"},{"doc":"Refreshes and returns the current ACME nonce.\n\nThis function retrieves the current nonce from the client's state. If no nonce\nis available, it automatically fetches a new one from the ACME server.\n\nThe nonce is a unique value provided by the ACME server that must be included\nin each request to prevent replay attacks.","ref":"ExAcme.html#current_nonce/1","title":"ExAcme.current_nonce/1","type":"function"},{"doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#current_nonce/1-parameters","title":"Parameters - ExAcme.current_nonce/1","type":"function"},{"doc":"- `{:ok, nonce}` - The current nonce value.\n  - `{:error, reason}` - If an error occurs during nonce retrieval.","ref":"ExAcme.html#current_nonce/1-returns","title":"Returns - ExAcme.current_nonce/1","type":"function"},{"doc":"Deactivates an existing ACME account.\n\nThis function sends a request to the ACME server to change the status of an account to 'deactivated'.\nOnce an account is deactivated, it cannot be used for any further operations and the change is irreversible.","ref":"ExAcme.html#deactivate_account/2","title":"ExAcme.deactivate_account/2","type":"function"},{"doc":"- `account_key` - The account key used for authentication, containing the Key ID (kid).\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#deactivate_account/2-parameters","title":"Parameters - ExAcme.deactivate_account/2","type":"function"},{"doc":"- `{:ok, account}` - If the account is successfully deactivated, returns the updated account information.\n  - `{:error, reason}` - If an error occurs during the deactivation process.","ref":"ExAcme.html#deactivate_account/2-returns","title":"Returns - ExAcme.deactivate_account/2","type":"function"},{"doc":"Retrieves the directory information from the client.","ref":"ExAcme.html#directory/1","title":"ExAcme.directory/1","type":"function"},{"doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#directory/1-parameters","title":"Parameters - ExAcme.directory/1","type":"function"},{"doc":"Checks if an external account is required.","ref":"ExAcme.html#external_account_required?/1","title":"ExAcme.external_account_required?/1","type":"function"},{"doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#external_account_required?/1-parameters","title":"Parameters - ExAcme.external_account_required?/1","type":"function"},{"doc":"Fetches account information from the specified URL.","ref":"ExAcme.html#fetch_account/3","title":"ExAcme.fetch_account/3","type":"function"},{"doc":"- `url` - The URL of the account to fetch.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#fetch_account/3-parameters","title":"Parameters - ExAcme.fetch_account/3","type":"function"},{"doc":"- `{:ok, account}` - If the account is successfully fetched.\n  - `{:error, reason}` - If an error occurs during the fetch operation.","ref":"ExAcme.html#fetch_account/3-returns","title":"Returns - ExAcme.fetch_account/3","type":"function"},{"doc":"Fetches order authorization information from the specified URL.","ref":"ExAcme.html#fetch_authorization/3","title":"ExAcme.fetch_authorization/3","type":"function"},{"doc":"- `url` - The URL of the authorization to fetch.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#fetch_authorization/3-parameters","title":"Parameters - ExAcme.fetch_authorization/3","type":"function"},{"doc":"- `{:ok, authorization}` - If the authorization is successfully fetched.\n  - `{:error, reason}` - If an error occurs during the fetch operation.","ref":"ExAcme.html#fetch_authorization/3-returns","title":"Returns - ExAcme.fetch_authorization/3","type":"function"},{"doc":"Fetches certificate chain from the specified URL.","ref":"ExAcme.html#fetch_certificates/3","title":"ExAcme.fetch_certificates/3","type":"function"},{"doc":"- `url` - The URL of the certificate to fetch.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#fetch_certificates/3-parameters","title":"Parameters - ExAcme.fetch_certificates/3","type":"function"},{"doc":"- `{:ok, certificate_chain}` - If the certificate chain is successfully fetched.\n  - `{:error, reason}` - If an error occurs during the fetch operation.","ref":"ExAcme.html#fetch_certificates/3-returns","title":"Returns - ExAcme.fetch_certificates/3","type":"function"},{"doc":"Fetches authorization challenge information from the specified URL.","ref":"ExAcme.html#fetch_challenge/3","title":"ExAcme.fetch_challenge/3","type":"function"},{"doc":"- `url` - The URL of the challenge to fetch.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#fetch_challenge/3-parameters","title":"Parameters - ExAcme.fetch_challenge/3","type":"function"},{"doc":"- `{:ok, challenge}` - If the challenge is successfully fetched.\n  - `{:error, reason}` - If an error occurs during the fetch operation.","ref":"ExAcme.html#fetch_challenge/3-returns","title":"Returns - ExAcme.fetch_challenge/3","type":"function"},{"doc":"Fetches order information from the specified URL.","ref":"ExAcme.html#fetch_order/3","title":"ExAcme.fetch_order/3","type":"function"},{"doc":"- `url` - The URL of the order to fetch.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#fetch_order/3-parameters","title":"Parameters - ExAcme.fetch_order/3","type":"function"},{"doc":"- `{:ok, order}` - If the order is successfully fetched.\n  - `{:error, reason}` - If an error occurs during the fetch operation.","ref":"ExAcme.html#fetch_order/3-returns","title":"Returns - ExAcme.fetch_order/3","type":"function"},{"doc":"Finalizes an order by sending a Certificate Signing Request (CSR) to the specified URL.","ref":"ExAcme.html#finalize_order/4","title":"ExAcme.finalize_order/4","type":"function"},{"doc":"- `finalize_url` - The URL to finalize the order.\n  - `csr` - The Certificate Signing Request (CSR) to send for finalization. You can generate a\n     CSR using the `ExAcme.Order.to_csr/2` function.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#finalize_order/4-parameters","title":"Parameters - ExAcme.finalize_order/4","type":"function"},{"doc":"- `{:ok, order}` - If the order is successfully finalized.\n  - `{:error, reason}` - If an error occurs during the finalization process.","ref":"ExAcme.html#finalize_order/4-returns","title":"Returns - ExAcme.finalize_order/4","type":"function"},{"doc":"Generates a cryptographic key pair for use with ACME operations.\n\nThis function creates a new key pair for signing ACME requests. The default\nalgorithm is ES256 (ECDSA using P-256 and SHA-256), which is widely supported\nby ACME providers.","ref":"ExAcme.html#generate_key/1","title":"ExAcme.generate_key/1","type":"function"},{"doc":"- `algorithm` - The algorithm to use for key generation. Default is \"ES256\".","ref":"ExAcme.html#generate_key/1-parameters","title":"Parameters - ExAcme.generate_key/1","type":"function"},{"doc":"- `JOSE.JWK` struct representing the generated key pair.","ref":"ExAcme.html#generate_key/1-returns","title":"Returns - ExAcme.generate_key/1","type":"function"},{"doc":"Retrieves the profiles from the ACME directory.","ref":"ExAcme.html#profiles/1","title":"ExAcme.profiles/1","type":"function"},{"doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#profiles/1-parameters","title":"Parameters - ExAcme.profiles/1","type":"function"},{"doc":"Registers a new account with the ACME server.\n\nThis function creates a new account on the ACME server using the provided registration information\nand JSON Web Key (JWK).","ref":"ExAcme.html#register_account/4","title":"ExAcme.register_account/4","type":"function"},{"doc":"- `registration_builder` - A `ExAcme.RegistrationBuilder` struct containing registration information\n    or a map with details from section 7.3 of RFC 8555.\n  - `key` - The JSON Web Key (JWK) to use for the account.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#register_account/4-parameters","title":"Parameters - ExAcme.register_account/4","type":"function"},{"doc":"- `{:ok, account, account_key}` - If the registration is successful, returns the account\n    information and the corresponding account key. An account key is the provided JSON Web Key\n    (JWK) and the Key Identifier (kid) returned by the server.\n  - `{:error, reason}` - If an error occurs during registration.","ref":"ExAcme.html#register_account/4-returns","title":"Returns - ExAcme.register_account/4","type":"function"},{"doc":"Revokes a previously issued certificate.\n\nThis function sends a request to the ACME server to revoke the specified certificate.\nOnce a certificate is revoked, it is no longer valid and cannot be reinstated.","ref":"ExAcme.html#revoke_certificate/3","title":"ExAcme.revoke_certificate/3","type":"function"},{"doc":"- `revocation_builder` - An `ExAcme.RevocationBuilder` struct or a map containing revocation details\n    such as the certificate data and optional reason code.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#revoke_certificate/3-parameters","title":"Parameters - ExAcme.revoke_certificate/3","type":"function"},{"doc":"- `:ok` - If the certificate is successfully revoked.\n  - `{:error, reason}` - If an error occurs during the revocation process.","ref":"ExAcme.html#revoke_certificate/3-returns","title":"Returns - ExAcme.revoke_certificate/3","type":"function"},{"doc":"Rotates the account key for an ACME account.\n\nThis function replaces the current account key with a new one. The server will authorize the key\nchange based on a request signed by both the old and new keys.","ref":"ExAcme.html#rotate_account_key/3","title":"ExAcme.rotate_account_key/3","type":"function"},{"doc":"- `old_account_key` - The current account key to be replaced.\n  - `new_key` - The new JSON Web Key (JWK) to use for the account.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#rotate_account_key/3-parameters","title":"Parameters - ExAcme.rotate_account_key/3","type":"function"},{"doc":"- `{:ok, account_key}` - If the key rotation is successful, returns the new account key, which\n     is the provided JSON Web Key (JWK) and the Key ID (kid).\n  - `{:error, reason}` - If an error occurs during key rotation.","ref":"ExAcme.html#rotate_account_key/3-returns","title":"Returns - ExAcme.rotate_account_key/3","type":"function"},{"doc":"Starts the validation process for a challenge by sending a request to the specified challenge URL.\n\nThis function notifies the ACME server that the client is ready for the server to attempt validation\nof the challenge. The server will then verify that the requirements of the challenge have been\nfulfilled.","ref":"ExAcme.html#start_challenge_validation/3","title":"ExAcme.start_challenge_validation/3","type":"function"},{"doc":"- `url` - The URL of the challenge to validate.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#start_challenge_validation/3-parameters","title":"Parameters - ExAcme.start_challenge_validation/3","type":"function"},{"doc":"- `{:ok, challenge}` - If the challenge validation request is successfully sent, returns the\n    updated challenge information.\n  - `{:error, reason}` - If an error occurs during the validation request.","ref":"ExAcme.html#start_challenge_validation/3-returns","title":"Returns - ExAcme.start_challenge_validation/3","type":"function"},{"doc":"Starts the ExAcme client agent with the given options.","ref":"ExAcme.html#start_link/1","title":"ExAcme.start_link/1","type":"function"},{"doc":"- `:directory_url` - The URL of the ACME directory. The value can be\n    `:lets_encrypt` or `:lets_encrypt_staging` to use the Let's Encrypt\n    production or staging directory URL, `:zerossl` to use ZeroSSL\n    directory URL, or a custom directory URL.\n  - Other options to pass to `Agent` like `:name`.","ref":"ExAcme.html#start_link/1-options","title":"Options - ExAcme.start_link/1","type":"function"},{"doc":"Submits a new order to the ACME server.\n\nThis function creates a new certificate order using the provided order information.\nIt can accept either an `ExAcme.OrderBuilder` struct or a map with order details from section 7.4\nof RFC 8555.","ref":"ExAcme.html#submit_order/3","title":"ExAcme.submit_order/3","type":"function"},{"doc":"- `order_builder` - An `ExAcme.OrderBuilder` struct or a map containing order details such as\n    identifiers, not_before, and not_after.\n  - `account_key` - The account key used for authentication.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#submit_order/3-parameters","title":"Parameters - ExAcme.submit_order/3","type":"function"},{"doc":"- `{:ok, order}` - If the order submission is successful, returns the order information.\n  - `{:error, reason}` - If an error occurs during order submission.","ref":"ExAcme.html#submit_order/3-returns","title":"Returns - ExAcme.submit_order/3","type":"function"},{"doc":"Retrieves the terms of service URL from the ACME directory information.","ref":"ExAcme.html#terms_of_service/1","title":"ExAcme.terms_of_service/1","type":"function"},{"doc":"- `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.html#terms_of_service/1-parameters","title":"Parameters - ExAcme.terms_of_service/1","type":"function"},{"doc":"Represents an [ACME Account object](https://datatracker.ietf.org/doc/html/rfc8555#section-7.1.2).\n\nProvides functionalities to fetch account details from the ACME server.","ref":"ExAcme.Account.html","title":"ExAcme.Account","type":"module"},{"doc":"- `url` - The URL of the account.\n  - `status` - The current status of the account.\n  - `contact_urls` - List of contact URLs.\n  - `terms_of_service_agreed` - Boolean indicating agreement to terms of service.\n  - `external_account_binding` - External account binding information.\n  - `orders_url` - URL to fetch the list of orders.","ref":"ExAcme.Account.html#module-attributes","title":"Attributes - ExAcme.Account","type":"module"},{"doc":"ACME Account object","ref":"ExAcme.Account.html#t:t/0","title":"ExAcme.Account.t/0","type":"type"},{"doc":"Handles the ACME account key operations.\n\nProvides functionalities to generate keys, sign requests, and manage key identifiers.","ref":"ExAcme.AccountKey.html","title":"ExAcme.AccountKey","type":"module"},{"doc":"- `key` - The JOSE JSON Web Key (JWK).\n  - `algorithm` - The algorithm of the key (e.g., ES256).\n  - `kid` - The Key ID assigned by the server.","ref":"ExAcme.AccountKey.html#module-attributes","title":"Attributes - ExAcme.AccountKey","type":"module"},{"doc":"Creates a new account key from a JOSE JSON Web Key (JWK) and the Key ID assigned by the server.","ref":"ExAcme.AccountKey.html#new/2","title":"ExAcme.AccountKey.new/2","type":"function"},{"doc":"- `key` - The JOSE JSON Web Key (JWK).\n  - `kid` - The Key ID assigned by the server.","ref":"ExAcme.AccountKey.html#new/2-parameters","title":"Parameters - ExAcme.AccountKey.new/2","type":"function"},{"doc":"- A new `ExAcme.AccountKey` struct.","ref":"ExAcme.AccountKey.html#new/2-returns","title":"Returns - ExAcme.AccountKey.new/2","type":"function"},{"doc":"Signs a request body with the account key.","ref":"ExAcme.AccountKey.html#sign/3","title":"ExAcme.AccountKey.sign/3","type":"function"},{"doc":"- `account_key` - The account key.\n  - `body` - The request body to sign.\n  - `header` - Additional headers.","ref":"ExAcme.AccountKey.html#sign/3-parameters","title":"Parameters - ExAcme.AccountKey.sign/3","type":"function"},{"doc":"- The signed JSON Web Signature (JWS).","ref":"ExAcme.AccountKey.html#sign/3-returns","title":"Returns - ExAcme.AccountKey.sign/3","type":"function"},{"doc":"Account key for authenticating requests","ref":"ExAcme.AccountKey.html#t:t/0","title":"ExAcme.AccountKey.t/0","type":"type"},{"doc":"Generates the thumbprint of the account key.","ref":"ExAcme.AccountKey.html#thumbprint/1","title":"ExAcme.AccountKey.thumbprint/1","type":"function"},{"doc":"- `account_key` - The account key.","ref":"ExAcme.AccountKey.html#thumbprint/1-parameters","title":"Parameters - ExAcme.AccountKey.thumbprint/1","type":"function"},{"doc":"- The thumbprint as a string.","ref":"ExAcme.AccountKey.html#thumbprint/1-returns","title":"Returns - ExAcme.AccountKey.thumbprint/1","type":"function"},{"doc":"Converts the account key to its public representation.","ref":"ExAcme.AccountKey.html#to_public/1","title":"ExAcme.AccountKey.to_public/1","type":"function"},{"doc":"- `account_key` - The account key.","ref":"ExAcme.AccountKey.html#to_public/1-parameters","title":"Parameters - ExAcme.AccountKey.to_public/1","type":"function"},{"doc":"- A map representing the public JSON Web Key (JWK).","ref":"ExAcme.AccountKey.html#to_public/1-returns","title":"Returns - ExAcme.AccountKey.to_public/1","type":"function"},{"doc":"Represents an [ACME Authorization object](https://datatracker.ietf.org/doc/html/rfc8555#section-7.1.4).\n\nProvides functionalities to fetch and process authorization details from the ACME server.","ref":"ExAcme.Authorization.html","title":"ExAcme.Authorization","type":"module"},{"doc":"- `url` - The URL of the authorization.\n  - `status` - The current status of the authorization.\n  - `expires` - Expiration datetime of the authorization.\n  - `identifier` - The identifier (e.g., domain) associated with the authorization.\n  - `challenges` - List of challenges available for the authorization.\n  - `wildcard` - Boolean indicating if the authorization is for a wildcard domain.","ref":"ExAcme.Authorization.html#module-attributes","title":"Attributes - ExAcme.Authorization","type":"module"},{"doc":"ACME Authorization object","ref":"ExAcme.Authorization.html#t:t/0","title":"ExAcme.Authorization.t/0","type":"type"},{"doc":"Represents an [ACME Challenge object](https://datatracker.ietf.org/doc/html/rfc8555#section-7.1.5).\n\nProvides functionalities to handle challenges required for validation.","ref":"ExAcme.Challenge.html","title":"ExAcme.Challenge","type":"module"},{"doc":"- `url` - The URL of the challenge.\n  - `status` - The current status of the challenge.\n  - `type` - The type of challenge (e.g., \"dns-01\").\n  - `token` - The challenge token.\n  - `validated` - Datetime when the challenge was validated.\n  - `error` - Any error associated with the challenge.","ref":"ExAcme.Challenge.html#module-attributes","title":"Attributes - ExAcme.Challenge","type":"module"},{"doc":"Finds a challenge of a specific type within an authorization.","ref":"ExAcme.Challenge.html#find_by_type/2","title":"ExAcme.Challenge.find_by_type/2","type":"function"},{"doc":"- `authorization` - The authorization object.\n  - `type` - The type of challenge to find (e.g., \"dns-01\").","ref":"ExAcme.Challenge.html#find_by_type/2-parameters","title":"Parameters - ExAcme.Challenge.find_by_type/2","type":"function"},{"doc":"- The challenge object if found, else `nil`.","ref":"ExAcme.Challenge.html#find_by_type/2-returns","title":"Returns - ExAcme.Challenge.find_by_type/2","type":"function"},{"doc":"Generates the key authorization string for a challenge.","ref":"ExAcme.Challenge.html#key_authorization/2","title":"ExAcme.Challenge.key_authorization/2","type":"function"},{"doc":"- `token` - The challenge token.\n  - `account_key` - The account key.","ref":"ExAcme.Challenge.html#key_authorization/2-parameters","title":"Parameters - ExAcme.Challenge.key_authorization/2","type":"function"},{"doc":"- The key authorization string.","ref":"ExAcme.Challenge.html#key_authorization/2-returns","title":"Returns - ExAcme.Challenge.key_authorization/2","type":"function"},{"doc":"ACME Challenge Object","ref":"ExAcme.Challenge.html#t:t/0","title":"ExAcme.Challenge.t/0","type":"type"},{"doc":"Represents an [ACME Order object](https://datatracker.ietf.org/doc/html/rfc8555#section-7.1.3).\n\nProvides functionalities to fetch, finalize, and parse order details from the ACME server.","ref":"ExAcme.Order.html","title":"ExAcme.Order","type":"module"},{"doc":"- `url` - The URL of the order.\n  - `status` - The current status of the order.\n  - `expires` - Expiration datetime of the order.\n  - `identifiers` - List of domain identifiers associated with the order.\n  - `profile` - The profile associated with the order.\n  - `not_before` - Start datetime of the order's validity.\n  - `not_after` - End datetime of the order's validity.\n  - `error` - Any error associated with the order.\n  - `authorizations` - List of authorization URLs.\n  - `finalize_url` - URL to finalize the order.\n  - `certificate_url` - URL to retrieve the issued certificate.","ref":"ExAcme.Order.html#module-attributes","title":"Attributes - ExAcme.Order","type":"module"},{"doc":"ACME Order object","ref":"ExAcme.Order.html#t:t/0","title":"ExAcme.Order.t/0","type":"type"},{"doc":"Generates a Certificate Signing Request (CSR) from an order and a private key.","ref":"ExAcme.Order.html#to_csr/2","title":"ExAcme.Order.to_csr/2","type":"function"},{"doc":"- `order` - The ACME order.\n  - `private_key` - The private key to sign the CSR and associate with the certificate.","ref":"ExAcme.Order.html#to_csr/2-parameters","title":"Parameters - ExAcme.Order.to_csr/2","type":"function"},{"doc":"- `X509.CSR` struct.","ref":"ExAcme.Order.html#to_csr/2-returns","title":"Returns - ExAcme.Order.to_csr/2","type":"function"},{"doc":"Represents an [ACME Order request](https://datatracker.ietf.org/doc/html/rfc8555#section-7.4).\n\nProvides functionalities to build and submit order requests to the ACME server.","ref":"ExAcme.OrderBuilder.html","title":"ExAcme.OrderBuilder","type":"module"},{"doc":"- `identifiers` - List of identifiers for the order.\n  - `profile` - The profile to apply to the order.\n  - `not_before` - Request start time for the certificate.\n  - `not_after` - Request end time for the certificate.","ref":"ExAcme.OrderBuilder.html#module-attributes","title":"Attributes - ExAcme.OrderBuilder","type":"module"},{"doc":"Adds a DNS identifier to the order request.","ref":"ExAcme.OrderBuilder.html#add_dns_identifier/2","title":"ExAcme.OrderBuilder.add_dns_identifier/2","type":"function"},{"doc":"- `order` - The current order request.\n  - `domain` - The domain name to add.","ref":"ExAcme.OrderBuilder.html#add_dns_identifier/2-parameters","title":"Parameters - ExAcme.OrderBuilder.add_dns_identifier/2","type":"function"},{"doc":"- Updated `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#add_dns_identifier/2-returns","title":"Returns - ExAcme.OrderBuilder.add_dns_identifier/2","type":"function"},{"doc":"Adds an identifier to the order request.","ref":"ExAcme.OrderBuilder.html#add_identifier/3","title":"ExAcme.OrderBuilder.add_identifier/3","type":"function"},{"doc":"- `order` - The current order request.\n  - `type` - The type of identifier (e.g., \"dns\").\n  - `value` - The value of the identifier (e.g., domain name).","ref":"ExAcme.OrderBuilder.html#add_identifier/3-parameters","title":"Parameters - ExAcme.OrderBuilder.add_identifier/3","type":"function"},{"doc":"- Updated `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#add_identifier/3-returns","title":"Returns - ExAcme.OrderBuilder.add_identifier/3","type":"function"},{"doc":"Creates a new order request with default values.","ref":"ExAcme.OrderBuilder.html#new_order/0","title":"ExAcme.OrderBuilder.new_order/0","type":"function"},{"doc":"- `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#new_order/0-returns","title":"Returns - ExAcme.OrderBuilder.new_order/0","type":"function"},{"doc":"Sets the requested end time for the certificate.","ref":"ExAcme.OrderBuilder.html#not_after/2","title":"ExAcme.OrderBuilder.not_after/2","type":"function"},{"doc":"- `order` - The current order request.\n  - `date` - The end datetime.","ref":"ExAcme.OrderBuilder.html#not_after/2-parameters","title":"Parameters - ExAcme.OrderBuilder.not_after/2","type":"function"},{"doc":"- Updated `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#not_after/2-returns","title":"Returns - ExAcme.OrderBuilder.not_after/2","type":"function"},{"doc":"Sets the requested start time for the certificate.","ref":"ExAcme.OrderBuilder.html#not_before/2","title":"ExAcme.OrderBuilder.not_before/2","type":"function"},{"doc":"- `order` - The current order request.\n  - `date` - The start datetime.","ref":"ExAcme.OrderBuilder.html#not_before/2-parameters","title":"Parameters - ExAcme.OrderBuilder.not_before/2","type":"function"},{"doc":"- Updated `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#not_before/2-returns","title":"Returns - ExAcme.OrderBuilder.not_before/2","type":"function"},{"doc":"Sets the profile for the order request.","ref":"ExAcme.OrderBuilder.html#profile/2","title":"ExAcme.OrderBuilder.profile/2","type":"function"},{"doc":"- `order` - The current order request.\n  - `profile` - The profile name.","ref":"ExAcme.OrderBuilder.html#profile/2-parameters","title":"Parameters - ExAcme.OrderBuilder.profile/2","type":"function"},{"doc":"- Updated `ExAcme.OrderBuilder` struct.","ref":"ExAcme.OrderBuilder.html#profile/2-returns","title":"Returns - ExAcme.OrderBuilder.profile/2","type":"function"},{"doc":"ACME Order request object","ref":"ExAcme.OrderBuilder.html#t:t/0","title":"ExAcme.OrderBuilder.t/0","type":"type"},{"doc":"Converts an order request to a map.\n\nThis function transforms the OrderBuilder struct into a map format,\nremoves nil values, and converts keys to camelCase for API compatibility.","ref":"ExAcme.OrderBuilder.html#to_map/1","title":"ExAcme.OrderBuilder.to_map/1","type":"function"},{"doc":"- `order` - The order request to convert.","ref":"ExAcme.OrderBuilder.html#to_map/1-parameters","title":"Parameters - ExAcme.OrderBuilder.to_map/1","type":"function"},{"doc":"- A map representation of the order.","ref":"ExAcme.OrderBuilder.html#to_map/1-returns","title":"Returns - ExAcme.OrderBuilder.to_map/1","type":"function"},{"doc":"Represents an [ACME Account registration](https://datatracker.ietf.org/doc/html/rfc8555#section-7.3).\n\nProvides functionalities to create and manage account registrations with the ACME server.","ref":"ExAcme.RegistrationBuilder.html","title":"ExAcme.RegistrationBuilder","type":"module"},{"doc":"- `contact` - List of contact URIs.\n  - `terms_of_service_agreed` - Boolean indicating agreement to terms.\n  - `only_return_existing` - Boolean to indicate if only existing accounts should be returned.\n  - `external_account_binding` - External account binding information.","ref":"ExAcme.RegistrationBuilder.html#module-attributes","title":"Attributes - ExAcme.RegistrationBuilder","type":"module"},{"doc":"Agrees to the terms of service for the registration.","ref":"ExAcme.RegistrationBuilder.html#agree_to_terms/1","title":"ExAcme.RegistrationBuilder.agree_to_terms/1","type":"function"},{"doc":"- `registration` - The current registration struct.","ref":"ExAcme.RegistrationBuilder.html#agree_to_terms/1-parameters","title":"Parameters - ExAcme.RegistrationBuilder.agree_to_terms/1","type":"function"},{"doc":"- Updated `ExAcme.RegistrationBuilder` struct.","ref":"ExAcme.RegistrationBuilder.html#agree_to_terms/1-returns","title":"Returns - ExAcme.RegistrationBuilder.agree_to_terms/1","type":"function"},{"doc":"Adds contact URIs to the registration.","ref":"ExAcme.RegistrationBuilder.html#contacts/2","title":"ExAcme.RegistrationBuilder.contacts/2","type":"function"},{"doc":"- `registration` - The current registration struct.\n  - `contacts` - A list or single contact URI.","ref":"ExAcme.RegistrationBuilder.html#contacts/2-parameters","title":"Parameters - ExAcme.RegistrationBuilder.contacts/2","type":"function"},{"doc":"- Updated `ExAcme.RegistrationBuilder` struct.","ref":"ExAcme.RegistrationBuilder.html#contacts/2-returns","title":"Returns - ExAcme.RegistrationBuilder.contacts/2","type":"function"},{"doc":"Configures the external account binding for the registration.\n\nThis function sets up an external account binding using the provided key, client,\nexternal account binding key ID, and MAC key.","ref":"ExAcme.RegistrationBuilder.html#external_account_binding/5","title":"ExAcme.RegistrationBuilder.external_account_binding/5","type":"function"},{"doc":"- `registration` - The current registration struct.\n  - `key` - The `JOSE.JWK` key being registered.\n  - `client` - The ExAcme client name or pid.\n  - `eab_kid` - The external account binding key ID.\n  - `eab_mac_key` - The external account binding MAC key. This must be a valid base64url-encoded\n     string.","ref":"ExAcme.RegistrationBuilder.html#external_account_binding/5-parameters","title":"Parameters - ExAcme.RegistrationBuilder.external_account_binding/5","type":"function"},{"doc":"- Updated `ExAcme.RegistrationBuilder` struct with external account binding.","ref":"ExAcme.RegistrationBuilder.html#external_account_binding/5-returns","title":"Returns - ExAcme.RegistrationBuilder.external_account_binding/5","type":"function"},{"doc":"Creates a new account registration struct with default values.","ref":"ExAcme.RegistrationBuilder.html#new_registration/0","title":"ExAcme.RegistrationBuilder.new_registration/0","type":"function"},{"doc":"- `ExAcme.RegistrationBuilder` struct.","ref":"ExAcme.RegistrationBuilder.html#new_registration/0-returns","title":"Returns - ExAcme.RegistrationBuilder.new_registration/0","type":"function"},{"doc":"ACME Account registration object","ref":"ExAcme.RegistrationBuilder.html#t:t/0","title":"ExAcme.RegistrationBuilder.t/0","type":"type"},{"doc":"Converts the registration struct to a map.\n\nThis function transforms the RegistrationBuilder struct into a map format,\nremoves nil values, and converts keys to camelCase for API compatibility.","ref":"ExAcme.RegistrationBuilder.html#to_map/1","title":"ExAcme.RegistrationBuilder.to_map/1","type":"function"},{"doc":"- `registration` - The current registration struct.","ref":"ExAcme.RegistrationBuilder.html#to_map/1-parameters","title":"Parameters - ExAcme.RegistrationBuilder.to_map/1","type":"function"},{"doc":"- A map representation of the registration.","ref":"ExAcme.RegistrationBuilder.html#to_map/1-returns","title":"Returns - ExAcme.RegistrationBuilder.to_map/1","type":"function"},{"doc":"Provides functions to build and manage HTTP requests for the ACME API.","ref":"ExAcme.Request.html","title":"ExAcme.Request","type":"module"},{"doc":"The type of the request body.","ref":"ExAcme.Request.html#t:body/0","title":"ExAcme.Request.body/0","type":"type"},{"doc":"Builds a fetch request with the given URL.","ref":"ExAcme.Request.html#build_fetch/1","title":"ExAcme.Request.build_fetch/1","type":"function"},{"doc":"- `url`: The URL to fetch.","ref":"ExAcme.Request.html#build_fetch/1-parameters","title":"Parameters - ExAcme.Request.build_fetch/1","type":"function"},{"doc":"- A request struct with the specified URL and an empty body.","ref":"ExAcme.Request.html#build_fetch/1-returns","title":"Returns - ExAcme.Request.build_fetch/1","type":"function"},{"doc":"Builds a named request by looking up the URL based on the given name and client.","ref":"ExAcme.Request.html#build_named/3","title":"ExAcme.Request.build_named/3","type":"function"},{"doc":"- `name`: The name identifier for the request URL.\n  - `body`: The content of the request body.\n  - `client`: The client used to fetch the directory information.","ref":"ExAcme.Request.html#build_named/3-parameters","title":"Parameters - ExAcme.Request.build_named/3","type":"function"},{"doc":"- A request struct with the looked-up URL and specified body.","ref":"ExAcme.Request.html#build_named/3-returns","title":"Returns - ExAcme.Request.build_named/3","type":"function"},{"doc":"Builds an update request with the given URL and body.","ref":"ExAcme.Request.html#build_update/2","title":"ExAcme.Request.build_update/2","type":"function"},{"doc":"- `url`: The URL to send the update to.\n  - `body`: The content of the request body.","ref":"ExAcme.Request.html#build_update/2-parameters","title":"Parameters - ExAcme.Request.build_update/2","type":"function"},{"doc":"- A request struct with the specified URL and body.","ref":"ExAcme.Request.html#build_update/2-returns","title":"Returns - ExAcme.Request.build_update/2","type":"function"},{"doc":"Looks up the URL associated with a given name from the client's directory.","ref":"ExAcme.Request.html#lookup_named_url/2","title":"ExAcme.Request.lookup_named_url/2","type":"function"},{"doc":"- `name`: The name identifier for the request URL.\n  - `client`: The client used to fetch the directory information.","ref":"ExAcme.Request.html#lookup_named_url/2-parameters","title":"Parameters - ExAcme.Request.lookup_named_url/2","type":"function"},{"doc":"- The URL associated with the given name in the directory.","ref":"ExAcme.Request.html#lookup_named_url/2-returns","title":"Returns - ExAcme.Request.lookup_named_url/2","type":"function"},{"doc":"Sends an HTTP request to the ACME API.\n\nThis function handles the actual HTTP communication with the ACME server,\nincluding signing the request with the provided key, handling nonce refreshes,\nand processing the response.","ref":"ExAcme.Request.html#send_request/3","title":"ExAcme.Request.send_request/3","type":"function"},{"doc":"- `request`: The request struct containing URL and body.\n  - `key` - The key used for authentication, it can either be an\n    `ExAcme.AccountKey` or a `JOSE.JWK` depending on if the account is\n    registered or not.\n  - `client` - The pid or name of the ExAcme client agent.","ref":"ExAcme.Request.html#send_request/3-parameters","title":"Parameters - ExAcme.Request.send_request/3","type":"function"},{"doc":"- `{:ok, %{body: body(), headers: map()}}` - On successful request.\n  - `{:error, reason}` - On failure, with details about the error.","ref":"ExAcme.Request.html#send_request/3-returns","title":"Returns - ExAcme.Request.send_request/3","type":"function"},{"doc":"Request object","ref":"ExAcme.Request.html#t:t/0","title":"ExAcme.Request.t/0","type":"type"},{"doc":"Provides functionality to build ACME certificate revocation requests.\n\nUse this module to construct a revocation request by supplying the certificate in one of several formats\n(`X509.Certificate` struct, DER binary, or PEM string) and an optional revocation reason.","ref":"ExAcme.RevocationBuilder.html","title":"ExAcme.RevocationBuilder","type":"module"},{"doc":"Sets the certificate for revocation using an X509 certificate struct.","ref":"ExAcme.RevocationBuilder.html#certificate/2","title":"ExAcme.RevocationBuilder.certificate/2","type":"function"},{"doc":"- `revocation`: The current revocation builder.\n  - `certificate`: An `X509.Certificate` struct representing the certificate to revoke.","ref":"ExAcme.RevocationBuilder.html#certificate/2-parameters","title":"Parameters - ExAcme.RevocationBuilder.certificate/2","type":"function"},{"doc":"- An updated `ExAcme.RevocationBuilder` struct with the certificate set.","ref":"ExAcme.RevocationBuilder.html#certificate/2-returns","title":"Returns - ExAcme.RevocationBuilder.certificate/2","type":"function"},{"doc":"Sets the certificate for revocation using a DER-encoded binary.","ref":"ExAcme.RevocationBuilder.html#certificate_der/2","title":"ExAcme.RevocationBuilder.certificate_der/2","type":"function"},{"doc":"- `revocation`: The current revocation builder.\n  - `der`: A binary containing the DER-encoded certificate.","ref":"ExAcme.RevocationBuilder.html#certificate_der/2-parameters","title":"Parameters - ExAcme.RevocationBuilder.certificate_der/2","type":"function"},{"doc":"- An updated `ExAcme.RevocationBuilder` struct with the certificate set.","ref":"ExAcme.RevocationBuilder.html#certificate_der/2-returns","title":"Returns - ExAcme.RevocationBuilder.certificate_der/2","type":"function"},{"doc":"Sets the certificate for revocation using a PEM-encoded string.","ref":"ExAcme.RevocationBuilder.html#certificate_pem/2","title":"ExAcme.RevocationBuilder.certificate_pem/2","type":"function"},{"doc":"- `revocation`: The current revocation builder.\n  - `pem`: A string containing the PEM-encoded certificate.","ref":"ExAcme.RevocationBuilder.html#certificate_pem/2-parameters","title":"Parameters - ExAcme.RevocationBuilder.certificate_pem/2","type":"function"},{"doc":"- `{:ok, revocation}` if successful and the PEM certificate is valid.\n  - `{:error, reason}` if the PEM certificate is invalid.","ref":"ExAcme.RevocationBuilder.html#certificate_pem/2-returns","title":"Returns - ExAcme.RevocationBuilder.certificate_pem/2","type":"function"},{"doc":"Creates a new revocation builder.","ref":"ExAcme.RevocationBuilder.html#new_revocation/0","title":"ExAcme.RevocationBuilder.new_revocation/0","type":"function"},{"doc":"- A new `ExAcme.RevocationBuilder` struct with no certificate or reason set.","ref":"ExAcme.RevocationBuilder.html#new_revocation/0-returns","title":"Returns - ExAcme.RevocationBuilder.new_revocation/0","type":"function"},{"doc":"Sets the revocation reason.\n\nAccepts either a named reason or a numeric reason code as defined in\n[RFC 5280](https://datatracker.ietf.org/doc/html/rfc5280#section-5.3.1).","ref":"ExAcme.RevocationBuilder.html#reason/2","title":"ExAcme.RevocationBuilder.reason/2","type":"function"},{"doc":"- `revocation`: The current revocation builder.\n  - `reason`: An atom representing the reason (`:unspecified`, `:key_compromise`,\n    `:affiliation_changed`, `:superseded`, or `:cessation_of_operation`) or an integer code.","ref":"ExAcme.RevocationBuilder.html#reason/2-parameters","title":"Parameters - ExAcme.RevocationBuilder.reason/2","type":"function"},{"doc":"- An updated `ExAcme.RevocationBuilder` struct with the reason set.","ref":"ExAcme.RevocationBuilder.html#reason/2-returns","title":"Returns - ExAcme.RevocationBuilder.reason/2","type":"function"},{"doc":"A certificate revocation builder","ref":"ExAcme.RevocationBuilder.html#t:t/0","title":"ExAcme.RevocationBuilder.t/0","type":"type"},{"doc":"Converts the revocation builder to a map.\n\nRemoves any keys with nil values and converts all keys to camelCase for API compatibility.","ref":"ExAcme.RevocationBuilder.html#to_map/1","title":"ExAcme.RevocationBuilder.to_map/1","type":"function"},{"doc":"- `revocation`: The revocation builder struct.","ref":"ExAcme.RevocationBuilder.html#to_map/1-parameters","title":"Parameters - ExAcme.RevocationBuilder.to_map/1","type":"function"},{"doc":"- A map representing the revocation request.","ref":"ExAcme.RevocationBuilder.html#to_map/1-returns","title":"Returns - ExAcme.RevocationBuilder.to_map/1","type":"function"},{"doc":"# ExAcme\n\n[![Hex.pm](https://img.shields.io/hexpm/v/ex_acme.svg)](https://hex.pm/packages/ex_acme)\n[![Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/ex_acme)\n[![License](https://img.shields.io/hexpm/l/ex_acme.svg)](https://github.com/jtdowney/ex_acme/blob/main/LICENSE)\n[![Build Status](https://img.shields.io/github/actions/workflow/status/jtdowney/ex_acme/ci.yaml?branch=main)](https://github.com/jtdowney/ex_acme/actions)\n\nExAcme is a lightweight, developer-friendly Elixir library for interacting with [RFC 8555-compliant](https://tools.ietf.org/html/rfc8555) ACME servers like [Let's Encrypt](https://letsencrypt.org). It simplifies the process of managing X.509 (TLS/SSL) certificates by providing a straightforward API for registering accounts, handling domain challenges, and issuing certificates.","ref":"readme.html","title":"ExAcme","type":"extras"},{"doc":"- Designed with developer productivity and Elixir idioms in mind.\n- Easy integration into your projects with minimal configuration.","ref":"readme.html#features","title":"Features - ExAcme","type":"extras"},{"doc":"- [Renewal information extension (DRAFT)](https://datatracker.ietf.org/doc/draft-ietf-acme-ari/)\n- Exposing `Retry-After` header information.","ref":"readme.html#missing","title":"Missing - ExAcme","type":"extras"},{"doc":"The package can be installed by adding `ex_acme` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:ex_acme, \"~> 0.5.1\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc) and published on [HexDocs](https://hexdocs.pm). The docs can be found at  .","ref":"readme.html#installation","title":"Installation - ExAcme","type":"extras"},{"doc":"","ref":"readme.html#examples","title":"Examples - ExAcme","type":"extras"},{"doc":"You can add ExAcme to your supervision tree.\n\n```elixir\nchildren = [\n  {ExAcme, name: MyAcme, directory_url: :lets_encrypt_staging}\n]\n```","ref":"readme.html#starting-the-client","title":"Starting the client - ExAcme","type":"extras"},{"doc":"To register a new account with the ACME server, you need to generate an account key, create a registration, and agree to the terms of service.\n\n```elixir\nalias ExAcme.RegistrationBuilder\n\n# Generate a new account key\nkey = ExAcme.generate_key()\n\n# Create and configure the registration\nregistration =\n  RegistrationBuilder.new_registration()\n  |> RegistrationBuilder.contacts([\"mailto:admin@example.com\"])\n  |> RegistrationBuilder.agree_to_terms()\n\n# Register the account\ncase ExAcme.register_account(registration, key, MyAcme) do\n  {:ok, account, account_key} ->\n    IO.puts(\"Account registered successfully!\")\n    IO.inspect(account)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to register account:\")\n    IO.inspect(reason)\nend\n```\n\n> [!IMPORTANT]\n> From now on you can use the `account_key` to perform operations on the account. This structure holds the JSON Web Key (JWK) associated with the account and the Key ID (kid) assigned by the ACME server.","ref":"readme.html#registering-an-account","title":"Registering an account - ExAcme","type":"extras"},{"doc":"Once you have registered an account, you can create an order for a certificate by specifying the domain(s) you wish to obtain certificates for.\n\n```elixir\nalias ExAcme.OrderBuilder\n\n# Create a new order request\norder_request =\n  OrderBuilder.new_order()\n  |> OrderBuilder.add_dns_identifier(\"example.com\")\n  |> OrderBuilder.add_dns_identifier(\"www.example.com\")\n\n# Submit the order\ncase ExAcme.submit_order(order_request, account_key, MyAcme) do\n  {:ok, order} ->\n    IO.puts(\"Order created successfully!\")\n    IO.inspect(order)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to create order:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#creating-an-order-request","title":"Creating an order request - ExAcme","type":"extras"},{"doc":"After creating an order, you need to complete the necessary challenges to prove ownership of the domain.\n\n```elixir\nalias ExAcme.Challenge\n\nfor auth_url <- order.authorizations do\n  {:ok, authorization} = ExAcme.fetch_authorization(auth_url, account_key, MyAcme)\n  challenge = Challenge.find_by_type(authorization, \"dns-01\")\n\n  if challenge do\n    value = Challenge.key_authorization(challenge.token, account_key)\n    # Set up challenge (implementation depends on your setup)\n    setup_challenge(authorization.identifier[\"value\"], value)\n\n    # Trigger validation\n    {:ok, _validated_challenge} = ExAcme.start_challenge_validation(challenge.url, account_key, MyAcme)\n\n    # Optionally, wait and verify the challenge status\n    :timer.sleep(5000)\n    {:ok, validated_challenge} = ExAcme.fetch_challenge(challenge.url, account_key, MyAcme)\n\n    if validated_challenge.status == \"valid\" do\n      IO.puts(\"Challenge for #{authorization.identifier[\"value\"]} validated successfully.\")\n    else\n      IO.puts(\"Challenge for #{authorization.identifier[\"value\"]} failed.\")\n    end\n  else\n    IO.puts(\"No challenge found for #{authorization.identifier[\"value\"]}.\")\n  end\nend\n```","ref":"readme.html#fetching-the-challenges-for-the-order","title":"Fetching the challenges for the order - ExAcme","type":"extras"},{"doc":"After all challenges are validated, you can finalize the order by submitting a CSR.\n\n```elixir\nalias ExAcme.Order\n\n# Create a private key for the certificate\nprivate_key = X509.PrivateKey.new_ec(:secp256r1)\n\n# Generate CSR from the order and private key\ncsr = Order.to_csr(order, private_key)\n\n# Finalize the order by submitting the CSR\ncase ExAcme.finalize_order(order.finalize_url, csr, account_key, MyAcme) do\n  {:ok, finalized_order} ->\n    IO.puts(\"Order finalized successfully!\")\n    IO.inspect(finalized_order)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to finalize order:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#finalizing-the-order-with-a-certificate-signing-request-csr","title":"Finalizing the order with a Certificate Signing Request (CSR) - ExAcme","type":"extras"},{"doc":"Once the order is finalized and the certificate is issued, you can fetch the certificate from the ACME server.\n\n```elixir\ncase ExAcme.fetch_certificates(finalized_order.certificate_url, account_key, MyAcme) do\n  {:ok, certificates} ->\n    Enum.each(certificates, fn cert ->\n      IO.puts(\"Fetched Certificate:\")\n      IO.puts(X509.Certificate.to_pem(cert))\n    end)\n\n  {:error, reason} ->\n    IO.puts(\"Failed to fetch certificate:\")\n    IO.inspect(reason)\nend\n```","ref":"readme.html#fetching-the-certificate","title":"Fetching the certificate - ExAcme","type":"extras"},{"doc":"This library is licensed under the [MIT License](https://opensource.org/licenses/MIT).","ref":"readme.html#license","title":"License - ExAcme","type":"extras"}],"producer":{"name":"ex_doc","version":"0.37.2"},"proglang":"elixir"}